using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace SdiAppSimple
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : SdiTemplate.SdiMainForm
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem menuItemEllipse;
		private System.Windows.Forms.MenuItem menuItemRectangle;
		private System.Windows.Forms.Panel panelScrollable;
        private MenuStrip menuStrip1;
        private ToolStripMenuItem fileToolStripMenuItem;
        private ToolStripMenuItem newToolStripMenuItem;
        private ToolStripMenuItem saveToolStripMenuItem;
        private ToolStripMenuItem openToolStripMenuItem;
        private ToolStripMenuItem viewToolStripMenuItem;
        private ToolStripMenuItem ellipseToolStripMenuItem;
        private ToolStripMenuItem rectangleToolStripMenuItem;
        private ToolStripMenuItem colorToolStripMenuItem;
        private ToolStripComboBox toolStripComboBoxBackColor;
		private System.Windows.Forms.MenuItem menuItemNew;

        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

            CreateDocument(typeof(Doc1));
            SetView("Rectangle", typeof(View1), panelScrollable);
			
            foreach(KnownColor color in Enum.GetValues(typeof(KnownColor))){
                toolStripComboBoxBackColor.Items.Add(color);
            }

            toolStripComboBoxBackColor.SelectedIndex = 0;

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.contextMenu1 = new System.Windows.Forms.ContextMenu();
            this.menuItemNew = new System.Windows.Forms.MenuItem();
            this.menuItemEllipse = new System.Windows.Forms.MenuItem();
            this.menuItemRectangle = new System.Windows.Forms.MenuItem();
            this.panelScrollable = new System.Windows.Forms.Panel();
            this.menuStrip1 = new System.Windows.Forms.MenuStrip();
            this.fileToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.newToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.saveToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.openToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.viewToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.ellipseToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.rectangleToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.colorToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.toolStripComboBoxBackColor = new System.Windows.Forms.ToolStripComboBox();
            this.menuStrip1.SuspendLayout();
            this.SuspendLayout();
            // 
            // contextMenu1
            // 
            this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemNew,
            this.menuItemEllipse,
            this.menuItemRectangle});
            // 
            // menuItemNew
            // 
            this.menuItemNew.Index = 0;
            this.menuItemNew.Text = "New";
            this.menuItemNew.Click += new System.EventHandler(this.menuItemNew_Click);
            // 
            // menuItemEllipse
            // 
            this.menuItemEllipse.Index = 1;
            this.menuItemEllipse.Text = "Ellipse";
            this.menuItemEllipse.Click += new System.EventHandler(this.menuItemEllipse_Click);
            // 
            // menuItemRectangle
            // 
            this.menuItemRectangle.Index = 2;
            this.menuItemRectangle.Text = "Rectangle";
            this.menuItemRectangle.Click += new System.EventHandler(this.menuItemRectangle_Click);
            // 
            // panelScrollable
            // 
            this.panelScrollable.AutoScroll = true;
            this.panelScrollable.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panelScrollable.Location = new System.Drawing.Point(0, 24);
            this.panelScrollable.Name = "panelScrollable";
            this.panelScrollable.Size = new System.Drawing.Size(292, 242);
            this.panelScrollable.TabIndex = 0;
            // 
            // menuStrip1
            // 
            this.menuStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.fileToolStripMenuItem,
            this.viewToolStripMenuItem,
            this.colorToolStripMenuItem});
            this.menuStrip1.Location = new System.Drawing.Point(0, 0);
            this.menuStrip1.Name = "menuStrip1";
            this.menuStrip1.Size = new System.Drawing.Size(292, 24);
            this.menuStrip1.TabIndex = 1;
            this.menuStrip1.Text = "menuStrip1";
            // 
            // fileToolStripMenuItem
            // 
            this.fileToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.newToolStripMenuItem,
            this.saveToolStripMenuItem,
            this.openToolStripMenuItem});
            this.fileToolStripMenuItem.Name = "fileToolStripMenuItem";
            this.fileToolStripMenuItem.Size = new System.Drawing.Size(35, 20);
            this.fileToolStripMenuItem.Text = "File";
            // 
            // newToolStripMenuItem
            // 
            this.newToolStripMenuItem.Name = "newToolStripMenuItem";
            this.newToolStripMenuItem.Size = new System.Drawing.Size(100, 22);
            this.newToolStripMenuItem.Text = "New";
            this.newToolStripMenuItem.Click += new System.EventHandler(this.newToolStripMenuItem_Click);
            // 
            // saveToolStripMenuItem
            // 
            this.saveToolStripMenuItem.Name = "saveToolStripMenuItem";
            this.saveToolStripMenuItem.Size = new System.Drawing.Size(100, 22);
            this.saveToolStripMenuItem.Text = "Save";
            this.saveToolStripMenuItem.Click += new System.EventHandler(this.saveToolStripMenuItem_Click);
            // 
            // openToolStripMenuItem
            // 
            this.openToolStripMenuItem.Name = "openToolStripMenuItem";
            this.openToolStripMenuItem.Size = new System.Drawing.Size(100, 22);
            this.openToolStripMenuItem.Text = "Open";
            this.openToolStripMenuItem.Click += new System.EventHandler(this.openToolStripMenuItem_Click);
            // 
            // viewToolStripMenuItem
            // 
            this.viewToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.ellipseToolStripMenuItem,
            this.rectangleToolStripMenuItem});
            this.viewToolStripMenuItem.Name = "viewToolStripMenuItem";
            this.viewToolStripMenuItem.Size = new System.Drawing.Size(41, 20);
            this.viewToolStripMenuItem.Text = "View";
            // 
            // ellipseToolStripMenuItem
            // 
            this.ellipseToolStripMenuItem.Name = "ellipseToolStripMenuItem";
            this.ellipseToolStripMenuItem.Size = new System.Drawing.Size(122, 22);
            this.ellipseToolStripMenuItem.Text = "Ellipse";
            this.ellipseToolStripMenuItem.Click += new System.EventHandler(this.ellipseToolStripMenuItem_Click);
            // 
            // rectangleToolStripMenuItem
            // 
            this.rectangleToolStripMenuItem.Name = "rectangleToolStripMenuItem";
            this.rectangleToolStripMenuItem.Size = new System.Drawing.Size(122, 22);
            this.rectangleToolStripMenuItem.Text = "Rectangle";
            this.rectangleToolStripMenuItem.Click += new System.EventHandler(this.rectangleToolStripMenuItem_Click);
            // 
            // colorToolStripMenuItem
            // 
            this.colorToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripComboBoxBackColor});
            this.colorToolStripMenuItem.Name = "colorToolStripMenuItem";
            this.colorToolStripMenuItem.Size = new System.Drawing.Size(66, 20);
            this.colorToolStripMenuItem.Text = "BackColor";
            this.colorToolStripMenuItem.DropDownOpening += new System.EventHandler(this.colorToolStripMenuItem_DropDownOpening);
            // 
            // toolStripComboBoxBackColor
            // 
            this.toolStripComboBoxBackColor.Name = "toolStripComboBoxBackColor";
            this.toolStripComboBoxBackColor.Size = new System.Drawing.Size(121, 21);
            this.toolStripComboBoxBackColor.SelectedIndexChanged += new System.EventHandler(this.toolStripComboBoxBackColor_SelectedIndexChanged);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(292, 266);
            this.ContextMenu = this.contextMenu1;
            this.Controls.Add(this.panelScrollable);
            this.Controls.Add(this.menuStrip1);
            this.MainMenuStrip = this.menuStrip1;
            this.Name = "Form1";
            this.Text = "Form1";
            this.menuStrip1.ResumeLayout(false);
            this.menuStrip1.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
            Application.Run(new Form1());
		}

		private void menuItemNew_Click(object sender, System.EventArgs e)
		{
			Doc.DeleteContents();
		}

		private void menuItemEllipse_Click(object sender, System.EventArgs e)
		{
			SetView("Ellipse", typeof(View2), panelScrollable);
		}

		private void menuItemRectangle_Click(object sender, System.EventArgs e)
		{
			SetView("Rectangle", typeof(View1), panelScrollable);
		}

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Doc.DeleteContents();
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ((Doc1)Doc).Deserialize();
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ((Doc1)Doc).Serialize();
        }

        private void ellipseToolStripMenuItem_Click(object sender, EventArgs e)
        {
            menuItemEllipse_Click(sender, e);
        }

        private void rectangleToolStripMenuItem_Click(object sender, EventArgs e)
        {
            menuItemRectangle_Click(sender, e);
        }

        private void colorToolStripMenuItem_DropDownOpening(object sender, EventArgs e)
        {
        }

        private void toolStripComboBoxBackColor_SelectedIndexChanged(object sender, EventArgs e)
        {
            ((Doc1)Doc).BackColor = 
                Color.FromKnownColor((KnownColor)toolStripComboBoxBackColor.SelectedItem);
        }
	}
}
